//******************************************
//           This is a C Template file
//
//
//
//ע
//******************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "MQ6811.h"
#include "MQ6801_REG_BIT.h"
//*****************************************************


//-- ض庯 --//
#ifndef	uchar
#define uchar unsigned char
#endif
#ifndef	uint
#define uint  unsigned int
#endif
#ifndef	ulong
#define ulong unsigned long
#endif

//-- 庯 --//
void delay_times(uchar tBase, uint x);
void Key_Wakeup_Init();
void Disable_Key_Wakeup();
void Active_STOP_mode();




//-- ȫֱ --//
uchar flag_WUC;


//-- ȫֳ --//
const uchar t_1ms   = 0;
const uchar t_100us = 1;
const uchar t_6u    = 2;	//HIRC: 8MHz, CGCR/4
const uchar t_3u    = 3;	//HIRC:16MHz, CGCR/4




void main()
{
//-----Disable P10 Reset-----P10趨ΪһIO
//	SYSCR3.byte = 0x01;
//	SYSCR4.byte = 0xB2;

	P1DR.byte = 0x00;
	P1CR.byte = 0xff;
	P4DR.byte = 0x00;
	P4CR.byte = 0xff;
	P7DR.byte = 0x00;
	P7CR.byte = 0xff;
	P8DR.byte = 0x00;
	P8CR.byte = 0xff;
	P9DR.byte = 0x00;
	P9CR.byte = 0xff;


	WDCDR.byte = 0x4e;				// clear wdt
//----------------------------------------//
//	Entry stop mode ............
//	1. stop modeעλܸ, ĩʹýλ趨Ϊλ,
//	   λӻδ֪©
	__asm("CPL (_P8DR).0");
	Key_Wakeup_Init();
	Active_STOP_mode();
	Disable_Key_Wakeup();			// 뿪 stop mode, KWI ܻᱣ趨, ʱҪ disable
	__asm("CPL (_P8DR).0");





	WDCDR.byte = 0x4e;				// clear wdt
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	while(1)
	{
		WDCDR.byte = 0x4e;			// clear wdt
	}
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
}






//*********************************************************************
// 	: Key_Wakeup_Init()
// 	: Key-on wakeup control
// ע		: MQ680144-pin趨ͬ
//*********************************************************************
void Key_Wakeup_Init()
{
	P4CR.byte = 0x00;
	P4PU.byte = 0xff;		//  stop release level 趨Ϊ Low level,
							// 趨 P4PU Ӧ֮裬
//..KWI 0.......................
	KWUCR0.bit.b1  = 0;		// stop release level, ( 0:Low / 1:high ) level
	KWUCR0.bit.b0  = 1;		// 1: KWI enable

//..KWI 1.......................
	KWUCR0.bit.b3  = 0;		// stop release level, ( 0:Low / 1:high ) level
	KWUCR0.bit.b2  = 1;		// 1: KWI enable

//..KWI 6.......................
	KWUCR1.bit.b5  = 0;		// stop release level, ( 0:Low / 1:high ) level
	KWUCR1.bit.b4  = 1;		// 1: KWI enable
}


//*********************************************************************
// 	: Disable_Key_Wakeup()
// 	: disable Key-on wakeup
// ע		: MQ680144-pin趨ͬ
//*********************************************************************
void Disable_Key_Wakeup()
{
	KWUCR0.byte  = 0x00;	// disable KWI0~3
	KWUCR1.byte  = 0x00;	// disable KWI4~7
}


//*********************************************************************
// 	: Active_STOP_mode()
// 	: start stop mode
// ע		: MQ680144-pin趨ͬ
//			: stop modeע:
//			: 1. λܸ, ĩʹýλ趨Ϊλ,
//			:    λӻδ֪©
//*********************************************************************
void Active_STOP_mode()
{
	SYSCR1.bit.b5 = 1;	// OUTEN=1, output hold at STOP mode
						// stop modeעλܸ, ĩʹýλ趨Ϊλ,
						// λӻδ֪©
	SYSCR1.bit.b6 = 1;	// RELM=1,  Level-sensitive release STOP mode
	SYSCR1.bit.b7 = 1;	// entry STOP mode
}









//*********************************************************************
// 	: delay_times(uchar tBase, uint x)
// 	: ʱ
// ע		: ==> t_1ms   = 0;
// 			: ==> t_100us = 1;
// 			: ==> t_6u    = 2;	//HIRC: 8MHz, CGCR/4
// 			: ==> t_3u    = 3;	//HIRC:16MHz, CGCR/4
// 			: ...
//*********************************************************************
void delay_times(uchar tBase, uint x)
{
	uint  i, cgcrT;
	uchar cgcrF[4]={ 2, 4,  8, 1 };		// HIRC =>  8MHz
//	uchar cgcrF[4]={ 4, 8, 16, 2 };		// HIRC => 16MHz

	cgcrT = cgcrF[CGCR.byte];			// 0:fc/4, 1:fc/2, 2:fc/1, 3:fc/8
	switch(tBase){
		case 0:		// t_1ms
			cgcrT *= 110;
			for(; x>0; x--)
				for(i=0; i<cgcrT; i++){}
			break;
		case 1:		// t_100us
			cgcrT *= 11;
			for(; x>0; x--)
				for(i=0; i<cgcrT; i++){}
			break;
		case 2:		// t_6u				// HIRC: 8MHz, CGCR/4
			for(; x>0; x--){}
			break;
		case 3:		// t_3u				// HIRC:16MHz, CGCR/4
			for(; x>0; x--){}
			break;
	}
	WDCDR.byte=0x4e; 			// clear wdt
}








